{$I Digi0.PAS}
{$I Digi1.PAS}
{$I Digiesp2.PAS}
{$I Digi3.PAS}

procedure FileMenu;
begin
  bx2:=255; by1:= 22; by2:= 56;
  Window(bx1,by1,bx2,by2);
  writexy(bx1+4,23,'Carga B');
  writexy(bx1+4,31,'Graba B');
  writexy(bx1+4,39,'Mezcla');
  writexy(bx1+4,47,'Fin');
  DigiIcon:= SelectMenu;
end;

procedure VideoMenu;
begin
  bx2:=bx1+130; by1:= 22; by2:=72;
  Window(bx1,by1,bx2,by2);
  writexy(bx1+4,23,'Ordenador');
  writexy(bx1+4,31,'Mezcla');
  writexy(bx1+4,39,'S.Impose Normal');
  writexy(bx1+4,47,'S.I Intensidad 1/2');
  writexy(bx1+4,55,'Video Blanco & Negro');
  writexy(bx1+4,63,'Video Color');
  DigiIcon:= SelectMenu + 20
end;

procedure SetMenu;
begin
  bx2:=bx1+130; by1:= 22; by2:=80;
  Window(bx1,by1,bx2,by2);
  writexy(bx1+4,23,'Automatico ? ');
           if auto = true then write('Si') else write('No');
  writexy(bx1+4,31,'Fondo      ? ');
           if digiback = true then write('Si') else write('No');
  writexy(bx1+4,39,'Fotos      ? ');
           if frames = true then write('Si') else write('No');
  writexy(bx1+4,47,'Coordenadas? ');
           if coordinates = true then write('Si') else write('No');
  writexy(bx1+4,55,'Numero Fotos : '); write(VertFrames:2,' ',HorFrames:2);
  writexy(bx1+4,63,'Pausa:  ');  write(Del:2);
  writexy(bx1+4,71,'Color: ');pencolor(Digicolor);write(chr(219));
  pencolor(tcolor);
  DigiIcon:= SelectMenu + 40
end;

procedure DigiMenu;
begin
  bx2:=bx1+68; by1:= 22; by2:=32;
  Window(bx1,by1,bx2,by2);
  writexy(bx1+4,23,'Empezar');
  DigiIcon:= SelectMenu + 60
end;

procedure EditMenu;
begin
  bx2:=bx1+56; by1:= 22; by2:=56;
  Window(bx1,by1,bx2,by2);
  writexy(bx1+4,23,'Borra');
  writexy(bx1+4,31,'Copia');
  writexy(bx1+4,39,'Mueve');
  writexy(bx1+4,47,'Lupa');
  DigiIcon:= SelectMenu + 80
end;

procedure DigiMain;
begin
  pencolor(Wcolor);
  logopr:=G_PSET;
  boxfill(0,0,255,21);
  drawmenuboxes;
  color(20,Wcolor,0);
  writexy(40,2,'Digitalizador para Oscar Lopez'); pencolor(tcolor);
  writexy(8,12,'Editar');
  writexy(64,12,'Video');
  writexy(110,12,'Opcion');
  writexy(158,12,'Digitiz');
  writexy(214,12,'Disco');
end;

procedure ChooseDigiMenu;
begin
  repeat
    WaitButton;
    if leftbutton then begin
      w:= (x div 51)+1; bx1:=(w-1)*51+2;
      drawinvbox(bx1,11,bx1+48,20);
      case w of
        1: EditMenu;
        2: VideoMenu;
        3: SetMenu;
        4: DigiMenu;
        5: FileMenu;
      end;
      drawbox(bx1,11,bx1+48,20);
    end;
if (InsideWin = true) or rightbutton then
  begin
  case DigiIcon of

      1: begin LoadBlk; Digimain end;
      2: begin SaveBlk; Digimain end;
      3: begin MergeBlk; Digimain end;
      4: begin Crtexit; V60Hz; halt end;

     21: begin ImposeOff; MixOff end;
     22: MixOn;
     23: ImposeFull;
     24: ImposeHalf;
     25: VideoBW;
     26: VideoColor;

     41: if auto = true then auto:= false else auto:= true;
     42: if digiback = true then digiback := false else digiback := true;
     43: if frames = true then frames:= false else frames := true;
     44: if coordinates= true then
            begin
            putsprite(26,-32,216);
            coordinates:= false
            end
          else coordinates:=true;
     45: GetDigiFrames;
     46: GetDigiDelay;
     47: GetColor;

     61: begin DigitizeScreen; DigiMain end;

     81: begin DeleteBlock; Digimain end;
     82: begin CopyBlock; Digimain end;
     83: begin MoveBlock; Digimain end;
     84: begin Zoom; DigiMain end;

  end;
  end;
  until false;
end;

procedure Initialize;
var i: byte;
begin
 crtinit;
 SetVDP(9,GetVDP(9) or 2);
 color(1,0,0);
 screen(8);
 Setpage(0,0);
 HiSpeedCopyPic(0,0,255,211,1,0,0,0);
 SetSpriteSize(2);
 DefSprite( 0, #252#130#130#132#130#145#104#4#2#1#0#0#0#0#0#0#0#0#0#0#0#0#128#64#32#64#128#0#0#0#0#0);
 DefSprite( 1, #0#124#4#8#4#2#1#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#128#64#0#0#0#0#0#0#0);
 DefSprite( 2, #0#124#124#120#124#110#7#3#1#0#0#0#0#0#0#0#0#0#0#0#0#0#0#128#192#128#0#0#0#0#0#0);
 DefSprite( 37,#112#136#136#136#168#136#136#136#112#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0);
 DefSprite( 38,#32#96#32#32#32#32#32#32#112#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0);
 DefSprite( 39,#112#136#8#8#16#32#64#128#248#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0);
 DefSprite( 40,#112#136#8#8#48#8#8#136#112#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0);
 DefSprite( 41,#16#48#80#144#144#248#16#16#16#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0);
 DefSprite( 42,#248#128#128#128#112#8#8#8#240#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0);
 DefSprite( 43,#112#136#128#128#240#136#136#136#112#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0);
 DefSprite( 44,#248#8#8#16#32#32#32#32#32#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0);
 DefSprite( 45,#112#136#136#136#112#136#136#136#112#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0);
 DefSprite( 46,#112#136#136#136#120#8#8#136#112#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0#0);

 SpriteColor(0,1);SpriteColor(1,15);SpriteColor(2,10);
 x:=126; y:=106; auto:= false; Blue:=0;
 digiback:=false; frames:= false; coordinates:=true;
 xframe:=0; yframe:=0;
 Vertframes:=1; Horframes:=1; Del:=4;
 Fcolor:=255; Bcolor:=0;DigiColor:=255;
 for i:= 0 to 2 do SpritePattern(i,i);
 for i:= 26 to 31 do begin SpritePattern(i,37); SpriteColor(i,15) end;
end;



begin
Initialize;
repeat
DigiMain;
ChooseDigiMenu;
until false;
end.
