
{ Read directory in array fi[] . Use procedure getdir . Juan Salas. 1990
       fi[] contains file names. nfiles contains number of files  }

type name = string[12];

var
    fi       : array[0..112] of name;
    nfiles   : integer;

procedure getdir;
var
  Error, Loop  : Integer;
  FCB          : array[0..25] of Byte absolute $005C;
  DMA          : string[32];

begin

  Error := BDos($1A,Addr(DMA));
  FCB[0] := 0;
  for Loop := 1 to 11 do FCB[Loop] := ord('?');

  Error := BDos($11,Addr(FCB));
  if Error <> 255 then begin
    nfiles:=0;
    mem[Addr(DMA)]:=12;
    fi[nfiles] := copy(dma,1,8)+'.'+copy(dma,9,3);
  end;

  repeat
    Error := BDos($12);
    if Error <> 255 then begin
       nfiles:= succ(nfiles);
       mem[addr(dma)]:=12;
       fi[nfiles] := copy(dma,1,8)+'.'+copy(dma,9,3);
    end
  until Error=255
end;

{ Utiliza el DRAW de ROM. Juan Salas. 1990 }

TYPE
 drstring = string[255];

procedure draw(s:drstring);
var j: integer;
begin
  s := chr(34) + s + chr(34)+chr(0);
  j := addr(s)+1;
  inline($2A/j/$DD/$21/$6E/$5D/$CD/_CALP1);
 end;

type _Copypicname = string[20];

procedure _CopyPic (code: integer);  { nur fr den internen Gebrauch!!! }
  type
    arr  = array [0..$0016] of byte;
    hook = record
             jump: byte;
             ad:   integer;
           end;
  var
    auxError: arr;
    SPsave:   integer;
    h_error:  hook absolute $FFB1;
    h_save:   hook;

  const
    errorcode: arr = ($D5,$3A,$41,$F3,$26,$00,$CD,$24,$00,$3A,$42,$F3,
                      $26,$40,$CD,$24,$00,$D1,$ED,$7B,$00,$00,$C9);

  begin
    auxError          := errorcode;
    auxError[20]      := lo(addr(SPsave));
    auxError[21]      := hi(addr(SPsave));
    h_save            := h_error;
    h_error.jump      := $C3;
    h_error.ad        := addr(auxError);

    inline ($CD/*+$001F/$7B/$B7/$CA/*+$0064/$01/$2E/$00/$DD/$21/$2D/$01/$CD/
            _CALSUB/$21/*+$003A/$7E/$B7/$28/$44/$BB/$28/$41/$23/$23/$18/$F5/
            $ED/$73/SPSAVE/$ED/$7B/RECURPTR/$2A/HEAPPTR/$CB/$7C/$20/$03/$21/
            $00/$80/$22/$C6/$F6/$B7/$ED/$72/$3F/$21/V9938COMMAND/$DD/$2A/CODE/
            $D4/_CALSUB/$ED/$7B/SPSAVE/$1E/$00/$D0/$1E/$05/$C9/$05/$90/$07/
            $07/$35/$01/$37/$99/$3E/$F1/$42/$F0/$43/$F1/$00/$FE/$23/$7E/$32/
            $D0/$00/$11/$77/$F5/$0E/$10/$CD/$05/$00);

    h_error := h_save;
  end;


procedure LoadPic (n: _Copypicname; x, y, direction: integer);
  begin
    n := '"' + n + '"'#0;
    V9938command.sx   := addr(n[1]);
    V9938command.dx   := x;
    V9938command.dy   := y + swap(ACPAGE);
    V9938command.arg  := direction shl 2;
    V9938command.l_op := LOGOPR;
    _CopyPic ($019D);
  end;


procedure SavePic (n: _Copypicname; x1,y1, x2,y2: integer);
  begin
    n := '"' + n + '"'#0;
    V9938command.sx   := x1;
    V9938command.sy   := y1 + swap(ACPAGE);
    V9938command.nx   := succ(abs(x2 - x1));
    V9938command.ny   := succ(abs(y2 - y1));
    V9938command.arg  := (ord(x1 > x2) shl 2) + (ord(y1 > y2) shl 3);
    V9938command.dx   := addr(n[1]);
    _CopyPic ($01A1);
    inline ($11/$77/$F5/$0E/$13/$3A/$D0/$00/$FE/$F0/$CC/$05/$00);
  end;
command.dx   := addr(n[1]);
    _CopyPic ($01A1);
    inline ($11/$77/$F5/$0E/$13/$3A/$D0/$00/$