

{$A+,U-,W1}
type string255 = string[255];
     filename  = string[14];
const
  G_PSET   =  0;  G_TPSET   =  8;
  G_AND    =  1;  G_TAND    =  9;
  G_OR     =  2;  G_TOR     = 10;
  G_XOR    =  3;  G_TXOR    = 11;
  G_PRESET =  4;  G_TPRESET = 12;
maxX = 255; maxY = 211;
var CALSLT: array[0..2] of byte absolute $001C;
procedure  ENASLT;external $0024;
var
ACPAGE:byte absolute $FAF6;
ATRBAS:integer absolute $F928;
ATRBYT:byte absolute $F3F2;
BAKCLR:byte absolute $F3EA;
BASE:  array[0..19] of integer absolute $F3B3;
BDRCLR:byte absolute $F3EB;
border:byte absolute BDRCLR;
CGPBAS:integer absolute $F924;
CNSDFG:byte absolute $F3DE;
CRTCNT:byte absolute $F3B1;
CSRX:  byte absolute $F3DD;
CSRY:  byte absolute $F3DC;
CSTYLE:boolean absolute $FCAA;
DPPAGE:byte absolute $FAF5;
EXBRSA:byte absolute $FAF8;
EXPTBL:array[0..3] of byte absolute $FCC1;
FILNAM:array[1..11]of byte absolute $F866;
FORCLR:byte absolute $F3E9;
GRPACX:integer absolute $FCB7;
GRPACY:integer absolute $FCB9;
GXPOS: integer absolute $FCB3;
GYPOS: integer absolute $FCB5;
ink:   byte absolute FORCLR;
LINL40:byte absolute $F3AE;
LINL32:byte absolute $F3AF;
LINLEN:byte absolute $F3B0;
LINWRK:array[0..39] of byte absolute $FC18;
LOGOPR:byte absolute $FB02;
NAMBAS:integer absolute $F922;
paper: byte absolute BAKCLR;
PATBAS:integer absolute $F926;
SCRMOD:byte absolute $FCAF;
TIME:  integer absolute $FC9E;
TXTCOL:integer absolute $F3B5;
VDPSAV1:array[0..7]of byte absolute $F3DF;
VDPSAV2:array[8..23]of byte absolute $FFE7;
VRAMflag:byte absolute $FAFC;
V9938command:record sx,sy,dx,dy,nx,ny:integer;col,arg,l_op:byte;end absolute $F562;

  MSX2,blinkflg,BlinkEnable: boolean;
  dxGRPPRT,_LINLEN,_wx1,_wy1,_wx2,_wy2,_nxpos: integer;
  AttrBits: array[0..239] of byte;

DRIVE:byte absolute $F247;

const
_CALROM: array[0..6] of byte = ($FD,$21,$00,$00,$C3,$D4,$20);
_CALSUB: array[0..6] of byte = ($FD,$21,$00,$00,$C3,$D4,$20);

procedure _CALP1;
begin
inline ($D9/$08/$DB/$A8/$32/*+$56/$E6/$03/$4F/$06/$00/$21/EXPTBL/$09/$B6/$F2/
        *+$13/$4F/$23/$23/$23/$23/$7E/$32/*+$48/$22/*+$47/$E6/$03/$07/$07/$B1/
        $32/*+$39/$21/*+$19/$E5/$ED/$5B/heapptr/$7A/$E6/$C0/$20/$03/$11/$4000/
        $D5/$21/*+$0C/$01/$22/$00/$ED/$B0/$C9/$FB/$08/$D9/$C9/$DD/$E5/$3A/
        EXPTBL/$21/$59/$01/$CD/$24/$00/$08/$D9/$DD/$E1/$CD/$59/$01/$D9/$08/$3E/
        $00/$D3/$A8/$3E/$00/$B7/$F0/$3E/$00/$32/$00/$00/$C9);
end;

procedure pencolor (n: byte);
  begin inline($32/ATRBYT/$32/FORCLR);end;

procedure SetVDP (register, value: byte);
  begin inline($4D/$3A/value/$47/$DD/$21/$47/$00/$C3/_CALROM); end;

function GetVDP (register: byte): byte;
  begin
    if register < 8
    then GetVDP:=VDPSAV1[register]
    else GetVDP:=VDPSAV2[register];
  end;

procedure ReadVRAM (VRAMaddress: integer;var RAMaddress;NumberOfbytes: integer);
  begin
   inline ($DD/$21/$59/$00/$ED/$4B/NumberOfbytes/$ED/$5B/RAMaddress/$2A/VRAMaddress/$C3/_CALROM);
  end;

procedure WriteVRAM (VRAMaddress:integer;var RAMaddress;NumberOfbytes: integer);
  begin
   inline ($DD/$21/$5C/$00/$ED/$4B/NumberOfbytes/$ED/$5B/VRAMaddress/$2A/RAMaddress/$C3/_CALROM);
  end;

procedure fillVRAM (VRAMaddress: integer;NumberOfbytes: integer;value: byte);
  begin
   inline ($DD/$21/$6B/$01/$ED/$4B/NumberOfbytes/$2A/VRAMaddress/$3A/value/$C3/_CALROM);
  end;

function vpeek (VRAMaddress: integer): byte;
  begin
    inline($DD/$21/$74/$01/$2A/VRAMaddress/$CD/_CALROM/$6F/$26/$00/$C9);
  end;

procedure vpoke (VRAMaddress: integer;value: byte);
begin
inline($DD/$21/$77/$01/$2A/VRAMaddress/$3A/value/$C3/_CALROM);
end;

procedure doV9938;
  begin
    inline ($21/$07/$00/$3A/$C1/$FC/$CD/$0C/$00/$4F/$0C/$11/$02/$8F/$F3/$ED/
            $59/$ED/$51/$ED/$78/$0F/$38/$FB/$AF/$ED/$79/$ED/$51/$11/$20/$91/
            $ED/$59/$ED/$51/$0C/$0C/$06/$0F/$21/V9938COMMAND/$ED/$B3/$FB);
  end;


procedure _CRTEXIT;begin CrtExit end;

procedure WriteXY (x, y: integer; s: string255);
  begin
   GRPACX:=x;GRPACY:=y;
   write(s)
  end;

procedure IOcheck;
var i: byte;
begin
i:= ioresult;
if i <> 0 then
 begin
 crtexit;
 write('I/O error: ',i);
 halt;
 end;
end;

procedure screen (n: byte);
  begin
    inline ($18/$06/$33/$14/$55/$02/$0F/$03/$FE/$04/$38/$12/$FE/$09/$30/$06/$3A/
    MSX2/$0F/$38/$08/$DD/$E1/$11/$91/$02/$C3/$2C/$20/$E5/$E1/$7D/
    $DD/$21/$5F/$00/$CD/_CALROM);
  end;

procedure CrtExit;
  begin
    inline ($DD/$21/$D2/$00/$CD/_CALROM);
    inline ($DD/$21/$85/$01/$CD/_CALSUB);CRTCNT:=24;
    _CRTEXIT;
  end;

procedure CLS;
  begin
  inline ($DD/$21/$15/$01/$C3/_CALSUB);
  end;

procedure CrtInit;

function constatus: boolean;
begin inline ($DD/$21/$9C/$00/$CD/_CALROM/$21/$00/$00/$C8/$23/$C9) end;

function conin: char;
var memo: integer;
begin memo:=LINLEN;LINLEN:=_LINLEN;
inline ($DD/$21/$9F/$00/$CD/_CALROM/$6F/$26/$00/$3A/memo/$32/LINLEN/$C9);
end;

{$A-}

procedure conout (chr: char);
const i: integer = 0;
begin
   inline ($DD/$21/$8D/$00/$3A/chr/$CD/_CALROM);
   case chr of
            #8: if GRPACX + dxGRPPRT >= 8
                  then GRPACX:=GRPACX + dxGRPPRT-8;
     #32..#255: if GRPACX >= dxGRPPRT
                  then GRPACX:=GRPACX - dxGRPPRT;
     end {case}
   end;
{$A+}

procedure Error (dummy1, dummy2: integer);
begin CrtExit;end;

  begin
    inline ($21/$00/$00/$39/$7C/$FE/$82/$30/$08/$DD/$E1/$11/$FF/$02/$C3/$2C/$20/
            $CD/$0A/$03/$11/$0B/$00/$2A/*+$0045/$19/$0E/$04/$11/$00/$00/$37/$F5/
            $06/$08/$F1/$F5/$30/$02/$CB/$06/$CB/$13/$CB/$12/$30/$08/$7A/$EE/$80/
            $57/$7B/$EE/$05/$5F/$10/$EA/$23/$0D/$20/$E4/$F1/$30/$05/$B7/$0E/$02/
            $18/$DB/$2B/$2B/$1B/$7B/$BE/$20/$05/$23/$7A/$BE/$28/$0D/$2A/*+$000A/
            $36/$F3/$23/$36/$76/$18/$03/$CD/SCREEN/$CD/$00/$02/$1B/$78/$35/$00/
            $21/$02/$00/$22/DXGRPPRT/$21/$20/$00/$3A/$AF/$FC/$3D/$28/$0D/$21/
            $28/$00/$3A/$B0/$F3/$FE/$29/$38/$03/$21/$50/$00/$22/_LINLEN/$11/$03/
            $00/$21/_CALROM/$19/$3A/$C1/$FC/$77/$23/$EB/$21/$1C/$00/$01/$03/$00/
            $ED/$B0);

    if EXBRSA <> 0
    then begin
      inline ($DD/$2A/$1D/$00/$11/$BF/$00/$DD/$19/$3E/$47/$DD/$BE/$00/$20/$44/
              $3E/$7B/$DD/$BE/$01/$20/$3D/$DD/$22/*+$0039/$F3/$DD/$36/$FD/$C3/
              $DD/$36/$FE/$9A/$DD/$36/$FF/$F3/$11/$9A/$F3/$21/*+$001B/$01/$0D/
              $00/$ED/$B0/$DB/$A8/$E6/$03/$5F/$16/$00/$21/$C5/$FC/$19/$DD/$75/
              $2D/$DD/$74/$2E/$FB/$18/$0D/$E5/$6F/$DB/$A8/$92/$E6/$03/$7D/$E1/
              $C0/$C3/$00/$00);
      _CALSUB[3] :=EXBRSA;move (CALSLT, _CALSUB[4], 3);
      LOGOPR     :=G_PSET;
      MSX2       :=TRUE;
      if (VRAMflag and 6) <> 0 then VRAMflag := VRAMflag or 8;
      SetVDP(8,GetVDP(8) and $DD);
      end
    else MSX2:=FALSE;

    ConStPtr:=addr(constatus);
    ConInPtr :=addr(conin);
    ConOutPtr:=addr(conout);
    ErrorPtr :=addr(Error);
  end;


procedure SetPage (dp, ap: integer);
  begin DPPAGE:=dp;ACPAGE:=ap;inline ($DD/$21/$3D/$01/$C3/_CALSUB);end;

procedure cwidth (n: integer);
  begin dxGRPPRT:=8-n;end;

procedure color (c1, c2, c3: byte);
  begin FORCLR:=c1;BAKCLR:=c2;BDRCLR:=c3;ATRBYT:=c1;inline ($DD/$21/$62/$00/$C3/_CALROM);end;

procedure scaleXY (var x, y: integer);
  begin
   inline ($2A/x/$4E/$23/$46/$2A/y/$5E/$23/$56/$DD/$21/$0E/$01/$CD/_CALROM/
           $72/$2B/$73/$2A/x/$71/$23/$70/$DD/$21/$11/$01/$CD/CALSLT/$FB);
  end;

procedure pset (x,y: integer);
  begin
   GXPOS:=x;GYPOS:=y;ScaleXY (x,y);
   inline ($DD/$21/$20/$01/$CD/_CALROM/$FB);
  end;

procedure preset (x,y: integer);
  var colorsave: integer;
  begin
   colorsave:=ATRBYT; ATRBYT:=BAKCLR; pset (x,y); ATRBYT := colorsave;
  end;

function point (x,y: integer): integer;
  begin
    if (x in [0..255]) and (y in [0..211]) then begin
      GXPOS:=x;GYPOS:=y;
      ScaleXY (x,y);
      inline ($DD/$21/$1D/$01/$CD/_CALROM/$FB/$6F/$26/$00/$C9);
    end;
    point:=-1
  end;

procedure line (x1,y1, x2,y2: integer);
  begin
   GXPOS:=x1;GYPOS:=y1;
   inline ($ED/$4B/x2/$ED/$5B/y2/$3A/SCRMOD/$FE/$02/$D8/$FE/$05/$38/$09/$DD/
           $21/$85/$00/$CD/_CALSUB/$18/$07/$DD/$21/$FC/$58/$CD/_CALP1);
   GXPOS:=x2;GYPOS:=y2;
  end;

procedure lineto (x,y: integer);
  begin
    inline ($ED/$4B/x/$ED/$5B/y/$3A/SCRMOD/$FE/$02/$D8/$FE/$05/$38/$09/$DD/$21/
            $85/$00/$CD/_CALSUB/$18/$07/$DD/$21/$FC/$58/$CD/_CALP1);
    GXPOS:=x;
    GYPOS:=y;
  end;

procedure boxfill (x1,y1, x2,y2: integer);
  begin
   GXPOS:=x2;GYPOS:=y2;
   inline ($ED/$4B/x1/$ED/$5B/y1/$3A/SCRMOD/$FE/$02/$D8/$FE/$05/$38/$07/$DD/
           $21/$CD/$00/$C3/_CALSUB/$DD/$21/$C1/$58/$C3/_CALP1);
  end;

procedure box (x1,y1, x2,y2: integer);
  begin
   GXPOS:=x2;GYPOS:=y2;
   inline ($ED/$4B/x1/$ED/$5B/y1/$DD/$21/$C9/$00/$C3/_CALSUB);
  end;

procedure VDPsync; begin inline ($FB/$76) end;
procedure ClrSprites; begin inline ($DD/$21/$69/$00/$C3/_CALROM); end;

procedure CopyPic (x1, y1, x2, y2, sp, x3, y3, dp: integer);
  begin
    V9938command.sx   := x1;
    V9938command.sy   := swap(sp) + y1;
    V9938command.dx   := x3;
    V9938command.dy   := swap(dp) + y3;
    V9938command.nx   := succ(abs(x2 - x1));
    V9938command.ny   := succ(abs(y2 - y1));
    V9938command.arg  := (ord(x1 > x2) shl 2) + (ord(y1 > y2) shl 3);
    V9938command.l_op := $90 + LOGOPR;
    doV9938;
  end;

procedure HiSpeedCopyPic (x1, y1, x2, y2, sp, x3, y3, dp: integer);
  begin
    V9938command.sx   := x1;
    V9938command.sy   := swap(sp) + y1;
    V9938command.dx   := x3;
    V9938command.dy   := swap(dp) + y3;
    V9938command.nx   := succ(abs(x2 - x1));
    V9938command.ny   := succ(abs(y2 - y1));
    V9938command.arg  := (ord(x1 > x2) shl 2) + (ord(y1 > y2) shl 3);
    V9938command.l_op := $D0;
    doV9938;
  end;

function strig(n: integer): boolean;
  begin
    inline ($3A/n/$DD/$21/$D8/$00/$CD/_CALROM/$E6/$01/$6F/$26/$00/$3A/n/$B7/
            $C0/$E5/$DD/$21/$56/$01/$CD/_CALROM/$E1/$C9);
  end;

function PAD(n: byte): integer;
  const
    value:  integer      = 0;
  begin
    inline ($3A/n/$DD/$21/$DB/$00/$CD/_CALROM/$32/value);
    if (value > 127)
    then PAD := value + $FF00
    else PAD := value;
  end;

procedure GetMouse (var x,y: integer);
  begin
    if boolean(pad(12)) then ;
    x := x + pad(13);
    y := y + pad(14);
    if (x<0) then x:=0 else if (x>255) then X:=255;
    if (y<0) then y:=0 else if (y>211) then y:=211;
  end;

function LeftButton : boolean;
  begin
    LeftButton := strig(1);
  end;

function RightButton : boolean;
  begin
    RightButton := strig(3);
  end;

procedure PutSprite (plane, x, y : byte);
type spriterecord  =
              record
              sy,sx : byte
              end;
var  base :  integer;
     sprite: spriterecord;	
  begin
    base := ATRBAS + (plane shl 2);
    if (x < 0) or (y < 0)  then vpoke (base, 217)
    else begin
    sprite.sx := x;
    sprite.sy := y;
    WriteVRAM(base,sprite,2)
  end;
end;

procedure SpritePattern (n, pattern: byte);
  begin
    if (GetVDP(1) and 3) > 1
    then vpoke (ATRBAS + (n shl 2) + 2, pattern shl 2)
    else vpoke (ATRBAS + (n shl 2) + 2, pattern);
  end;

procedure SpriteColor (n, color: byte);
  var
    base:      integer;
  begin
      base := ATRBAS-512 + (n shl 4);
      fillVRAM (base, 16, (vpeek(base) and $80) + color);
  end;

procedure SetSpriteSize (n: byte);
var i : integer;
begin
i := GetVDP(1);
SetVDP(1,(i and $FC)+(n and 3));
if (i and 2) <> (n and 2) then
 for i:= 0 to 31 do SpritePattern(i,i)
end;

procedure V60Hz;
begin
setVDP(9,GetVDP(9) and 253);
end;

procedure V50Hz;
begin
SetVDP(9,GetVDP(9) or 2);
end;

procedure ImposeFull;
begin
port[$F7]:=159;
SetVDP(9,GetVDP(9) and $DF or $10)
end;

procedure ImposeHalf;
begin
port[$F7]:=191;
SetVDP(9,GetVDP(9) and $DF or $10)
end;

procedure ImposeOff;
begin
port[$F7]:=$FF;
SetVDP(9,GetVDP(9) and $EF)
end;

procedure VideoColor;
begin
SetVDP(9,GetVDP(9) and 239 or 32);
port[$F7]:=95;
port[$F6]:=255;
repeat until not leftbutton;
repeat until leftbutton;
SetVDP(9,GetVDP(9) and 223);
port[$F7]:=255;
end;

procedure VideoBW;
begin
SetVDP(9,GetVDP(9) and 239 or 32);
port[$F7]:=95;
port[$F6]:=239;
repeat until not leftbutton;
repeat until leftbutton;
SetVDP(9,GetVDP(9) and 223);
port[$F7]:=255;
end;

procedure MixOn;
begin
ImposeFull;
port[$F6]:=port[$F6] and $DF
end;

procedure MixOff;
begin
ImposeOff;
port[$F6]:=$FF
end;

procedure DigitizeView(c:byte);
begin
ImposeFull;
SetVDP(8,GetVDP(8) or 32);
SetVDP(7,c);
SetVDP(0,GetVDP(0) or $40)
end;

procedure wait(d : integer);
begin
time:=0;
repeat until time > d;
end;

procedure DigitizeSet;
begin
SetVDP(0,GetVDP(0) and $BF);
wait(2);
SetVDP(7,183);
PutSprite(0,-32,216)
end;

procedure MoveCursor(x,y: byte);
var i: byte;
begin
for i:= 0 to 2 do putsprite(i,x,y);
end;

procedure HideCursor;
var i: byte;
begin
for i:= 0 to 2 do putsprite(i,-32,-32);
end;

type
  Sprite8  = string[8];
  Sprite16 = string[16];
  Sprite32 = string[32];


procedure DefSprite (n: byte; pattern: Sprite32);

  var
    size:   byte;
    length: byte absolute pattern;

  begin
    inline ($DD/$21/$8A/$00/
            $CD/_CALROM/
            $32/size);
    if length < size
    then fillchar(pattern[succ(length)], size-length, #0);
    writeVRAM (PATBAS + size * n, pattern[1], size);
  end;
